/**
  * Java Service Launcher
  *
*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <time.h>
#include <direct.h>
#include <Rpcdce.h>
#include <Rpc.h>

#include "service.h"
#define EXPAND_CLASSPATH_WILDCARDS

#include "wildcard.h"

//service name
LPTSTR szappname;
LPTSTR szservicename;
LPTSTR szdisplayname;
LPTSTR szservicedescription;
LPTSTR szconsolehandler;
LPTSTR szdependencies;
LPTSTR szLoadOrderGroup;
LPTSTR szAccount;
LPTSTR szPwd;
LPTSTR szCmdLine;
DWORD dwStartType;

LPTSTR stopClass;
LPTSTR stopMethod;
LPTSTR stopSignature;
LPTSTR path;

LPTSTR szSystemOutAppend;
LPTSTR szSystemErrAppend;

LPTSTR szinteractwithdesktop;

// 0.99d - 19.02.2003 Urs Bloechlinger
LPTSTR szStdOutAppend;
LPTSTR szStdErrAppend;

int stopport;
int global_argc;
int startdelay = 0;
LPTSTR  global_jrePath;
LPTSTR  global_wrkdir;
LPTSTR  global_jvmtype;
LPTSTR* global_argv;

// internal variables
SERVICE_STATUS          ssStatus;       // current status of the service
SERVICE_STATUS_HANDLE   sshStatusHandle;
DWORD                   dwErr = 0;
#ifdef _DEBUG
BOOL                    bDebug = TRUE;
#endif
#ifdef NDEBUG
BOOL                    bDebug = FALSE;
#endif

BOOL                    bCommandLine = FALSE;
BOOL					bService = FALSE;
BOOL					bCommandLineDebug = FALSE;
BOOL					useConsoleHandler =TRUE;
BOOL					bPaused = FALSE;
TCHAR                   szErr[256];

//p0.99
//redirected stdout and stderr
FILE* restdout = NULL;
FILE* restderr = NULL;
LPTSTR stdoutfile = NULL;
LPTSTR stderrfile = NULL;
LPTSTR logfile = NULL;
LPTSTR logtimestamp = NULL;


int	exceptionErrorCode = 0; 
LPTSTR onExitError = "";
LPTSTR szModulePath = "";
LPTSTR szreportservicestoppedonmainthreadexit = FALSE;
BOOL breportservicestoppedonmainthreadexit = FALSE;

// internal function prototypes
int tokenize( char* s, char delim );
LPTSTR* stringToArray(char* s, char delim );
LPTSTR next_token( char* s, LPTSTR token );
VOID WINAPI service_ctrl(DWORD dwCtrlCode);
void CmdAddServiceParameterRegistry();
VOID WINAPI service_main(DWORD dwArgc, LPTSTR *lpszArgv);
VOID CmdInstallService( int argc, LPTSTR* argv );
VOID CmdConfigureService( int argc, LPTSTR* argv );
VOID CmdRemoveService();
VOID CmdDebugService(int argc, LPTSTR* argv);
VOID CmdRunService(int argc, LPTSTR* argv);
BOOL WINAPI ControlHandler ( DWORD dwCtrlType );
//BOOL WINAPI ControlHandler2 ( DWORD dwCtrlType );
LPTSTR GetLastErrorText( LPTSTR lpszBuf, DWORD dwSize );

//
//  FUNCTION: main
//
//  PURPOSE: entrypoint for service
//
//  PARAMETERS:
//    argc - number of command line arguments
//    argv - array of command line arguments
//
//  RETURN VALUE:
//    none
//
//  COMMENTS:
//    main() either performs the command line task, or
//    call StartServiceCtrlDispatcher to register the
//    main service thread.  When the this call returns,
//    the service has stopped, so exit.
//
void main(int argc, LPTSTR* argv)
{	
    SERVICE_TABLE_ENTRY dispatchTable[] =
    {
        { TEXT(SZSERVICENAME), (LPSERVICE_MAIN_FUNCTION)service_main },
        { NULL, NULL }
    };
	//Backup parameters to executable, they become overwritten with the java args
	LPTSTR* _argv = argv;
	int _argc = argc;

    returnCode = RET_DEFAULT;
	InitializeCriticalSection( &csLog );
	if ( bDebug )
	{
		SYSTEM_INFO siSysInfo;
 
	   // Copy the hardware information to the SYSTEM_INFO structure. 
	 
	   GetSystemInfo(&siSysInfo); 
	 
	   // Display the contents of the SYSTEM_INFO structure. 

	   printf("Hardware information: \n");  
	   printf("  OEM ID: %u\n", siSysInfo.dwOemId);
	   printf("  Number of processors: %u\n", 
		  siSysInfo.dwNumberOfProcessors); 
	   printf("  Page size: %u\n", siSysInfo.dwPageSize); 
	   printf("  Processor type: %u\n", siSysInfo.dwProcessorType); 
	   printf("  Minimum application address: %lx\n", 
		  siSysInfo.lpMinimumApplicationAddress); 
	   printf("  Maximum application address: %lx\n", 
		  siSysInfo.lpMaximumApplicationAddress); 
	   printf("  Active processor mask: %u\n", 
		  siSysInfo.dwActiveProcessorMask); 
	}

    if ( (argc > 1) &&
         ((*argv[1] == '-') || (*argv[1] == '/')) )
    {
        if ( _stricmp( "install", argv[1]+1 ) == 0 )
        {
					getParams( &argc, &argv, FALSE, TRUE );
					dispatchTable[0].lpServiceName = szservicename;					
					CmdInstallService( _argc, _argv );
        }
		else if ( _stricmp( "configure", argv[1]+1 ) == 0 )
        {
					getParams( &argc, &argv, FALSE, TRUE );
					dispatchTable[0].lpServiceName = szservicename;
					CmdConfigureService( _argc, _argv );
        }
        else if ( _stricmp( "remove", argv[1]+1 ) == 0 )
        {
					getParams( &argc, &argv, FALSE, TRUE );
					dispatchTable[0].lpServiceName = szservicename;
					CmdRemoveService();
        }
        else if ( _stricmp( "debug", argv[1]+1 ) == 0 )
        {
                    bDebug = TRUE;
					getParams( &argc, &argv, FALSE, TRUE );
					dispatchTable[0].lpServiceName = szservicename;
					bCommandLine = TRUE;
					bCommandLineDebug = TRUE;
					CmdDebugService(argc, argv);
        }
		else if ( _stricmp( "run", argv[1]+1 ) == 0 )
        {
				  //16.05.01 Erwin Vervondel
				  //Allow to run as a standalone application
					getParams( &argc, &argv, FALSE, FALSE );
					dispatchTable[0].lpServiceName = szservicename;
					bCommandLine = TRUE;
					if ( bDebug )
						logToFile( "Calling CmdRunService" );
					CmdRunService(argc, argv);
        }
        else
        {
            goto dispatch;
        }
		exit( returnCode );
    }

    // if it doesn't match any of the above parameters
    // the service control manager may be starting the service
    // so we must call StartServiceCtrlDispatcher
    dispatch:
						      
		printf( "JSL Java Service Launcher by Michael Roeschter (Michael@Roeschter.com)\nVersion 0.99p December 2015\n" );
		printf( "Command line options:\n" );
		printf( "%s -install [ini]    to install the service\n", argv[0] );
		printf( "%s -configure [ini]  to reconfigure an installed service with new dependencies\n", argv[0] );
		printf( "%s -remove [ini]     to remove the service\n", argv[0] );
		printf( "%s -debug [ini]      to run as a console app for debugging\n", argv[0] );
		printf( "%s -run [ini]        to run as a standalone console app\n", argv[0] );
		printf( "%s -ini ini          to use the specified init file for running as a service (this option is not useful on command line; only use it if you configure the service option in the registry)\n", argv[0] );
		printf( "The configurations file used in the -install and -configure commands will be used for running the service." );
		

		//Read parameters from the ini file for this service	
		getParams( &argc, &argv, TRUE, TRUE);

		global_argc = argc;
		global_argv = argv;

		if ( bDebug )
			logToFile( "params read, calling dispatcher" );		

        printf( "\nStartServiceCtrlDispatcher being called.\n" );
        printf( "This may take several seconds.  Please wait.\n" );
		
		bService = TRUE;
		dispatchTable[0].lpServiceName = szservicename;	

        if (!StartServiceCtrlDispatcher(dispatchTable))
		{
            AddToMessageLog(TEXT("StartServiceCtrlDispatcher failed."));
			if ( bDebug )
			{
				logToFile( GetLastErrorText(szErr, 256) );
				logToFile( "StartServiceCtrlDispatcher failed" );
			}
		}

		if ( bDebug )
			logToFile( "StartServiceCtrlDispatcher returned" );
		
		exit( returnCode );
}

// 0.99d - 19.02.2003 Urs Bloechlinger
// Converts kernel time to the string-format given in psTime (i.e. "%Y.%m.%d_%H:%M:%S").
void dateTimeToString (char* psTime, char* TimeFormat)
{
	size_t iMaxSize = 64;
	time_t tTime;
	struct tm pTimeStruct;

	time(&tTime);
	localtime_s(&pTimeStruct, &tTime);
	strftime (psTime, iMaxSize, TimeFormat , &pTimeStruct);
}

BOOL boolVal( char* str)
{
	if ( strcmp( str, "FALSE" ) == 0 )
		return FALSE;
	if ( strcmp( str, "False" ) == 0 )
		return FALSE;
	if ( strcmp( str, "false" ) == 0 )
		return FALSE;
	if ( strcmp( str, "NO" ) == 0 )
		return FALSE;
	if ( strcmp( str, "No" ) == 0 )
		return FALSE;
	if ( strcmp( str, "no" ) == 0 )
		return FALSE;

	if ( strcmp( str, "TRUE" ) == 0 )
		return TRUE;
	if ( strcmp( str, "True" ) == 0 )
		return TRUE;
	if ( strcmp( str, "true" ) == 0 )
		return TRUE;
	if ( strcmp( str, "YES" ) == 0 )
		return TRUE;
	if ( strcmp( str, "Yes" ) == 0 )
		return TRUE;
	if ( strcmp( str, "yes" ) == 0 )
		return TRUE;

	return FALSE;
}

/**
  * Read parameters from the configuration file 
*/
void getParams(int *pargc, LPTSTR** pargv, boolean show, boolean runAsService)
{
    int argc = *pargc;
    LPTSTR* argv = *pargv;
    int nargc; 
    LPTSTR* nargv;
    int i;
	size_t i_p;

	FILE* iniFile;

	LPTSTR _java = "java";
	LPTSTR _service = "service";
	LPTSTR _defines = "defines";
	
	int params;
	LPTSTR _param = malloc( 8 );

	size_t bsize = 16000;
	LPTSTR buffer;
	LPTSTR commandLine;
	LPTSTR commandLineStart;
	LPTSTR export;

	size_t pos = 0;
	size_t cpos = 0;
	size_t size = 0;
	int currentParam = 0;
	int startParam = 0;
	char* stmp;
	char* pathformat;
	char* cmdpathformat;
	char* cmdarg;
	//char* nameformat;
	int isclasspath = 0;

	//Number of static parameters of type 
	//Add 1 here if you add new -D style parameters
	int STATIC_PARAMS = 5;

	TCHAR cszPath[_MAX_PATH ];
	LPSTR szPath = cszPath;
	BOOL   explicitIni = FALSE;

	TCHAR szDrive[_MAX_DIR];
	TCHAR szDir[_MAX_DIR];    
	TCHAR szFname[_MAX_FNAME];
	TCHAR szExt[_MAX_EXT];

	TCHAR szmName[_MAX_PATH];
	TCHAR szmDrive[_MAX_DIR];
	TCHAR szmDir[_MAX_DIR];  
	TCHAR szmFname[_MAX_FNAME];
	TCHAR smzExt[_MAX_EXT];

	
	#pragma warning(disable:4267)
	bsize = GetPrivateProfileInt( _service, "stringbuffer", bsize, szPath );
	#pragma warning(default:4267)

	buffer = malloc( bsize );	
	commandLine = malloc( bsize );
	commandLineStart = commandLine;

	if ( show )
	  printf( "%s=%li\n", "stringbuffer", bsize );

	strcpy_s( _param, 8 , "param00" );

	GetModuleFileName( NULL, szmName,_MAX_PATH );
	if ( GetModuleFileName( NULL, szmName, 512 ) == 0)
	{
		AddToMessageLog(TEXT("Could not get module name, so in consequence could not locate ini file."));	
		exit( 1 );
	}
	_splitpath_s( szmName, szmDrive, _MAX_DIR, szmDir, _MAX_DIR, szmFname, _MAX_FNAME, smzExt,_MAX_EXT );
	printf( "Module name decomposed %s %s %s %s\n", szmDrive, szmDir, szmFname, smzExt );

	//printf( "%s\n", argv[1]);
	//Specify the location of the ini file
	if ( argc >= 3  ) // strcmp( argv[1], "-ini" )==0
	{
		if ( bDebug )
			printf( "Explicitly named ini file\n" );

		strcpy_s( szPath, _MAX_PATH, argv[2] );
		explicitIni = TRUE;
		
		_splitpath_s( szPath, szDrive, _MAX_DIR, szDir, _MAX_DIR, szFname, _MAX_FNAME, szExt,_MAX_EXT );
		printf( "Ini file decomposed %s:%s:%s:%s\n", szDrive, szDir, szFname, szExt );
		//Splitpath can't handle UNC names. So lets rectify that.  drive="" and dir="\\server\dir" needs to become drive="\\server" and dir="\dir" 
		if ( szDir != NULL && szDir[0] == '\\' && szDir[1] == '\\' )
		{
			i = 2;
			while( szDir[i] != 0 && szDir[i] != '\\' )
			{
				i++;
			}
			strcpy_s( szDrive, _MAX_DIR, szDir );
			strcpy_s( szDir, _MAX_DIR, szDrive+i );
			szDrive[i] = 0;
			//strcpy_s( szDrive, _MAX_DIR, szDrive+i );		
		}
		printf( "Ini file decomposed %s:%s:%s:%s\n", szDrive, szDir, szFname, szExt );
		 
		//Check if relative path, in this case merge to module path. Other wise just continue and reassemble
		if( szDrive == NULL || strlen( szDrive ) == 0 )
		{			
			//If no drive in path assume drive from executable
			strcpy_s( szDrive, _MAX_DIR, szmDrive );
			if( szDir == NULL || strlen( szDir ) == 0 )
				//If no directory in path assume directory from executable
				strcpy_s( szDir, _MAX_DIR, szmDir );
			else {
				if ( szDir[0] == '.' )
				{
					//If ini directory start with a . then drop first two characters and append to executable directory
					strcat_s( szmDir,_MAX_DIR, szDir+2 );
					strcpy_s( szDir, _MAX_DIR, szmDir );			
				} else {
					//Otherwise just append to executable directory
					strcat_s( szmDir,_MAX_DIR, szDir );
					strcpy_s( szDir, _MAX_DIR, szmDir );	
				}
			}
		}		 
		 printf( "Ini file new %s %s %s %s\n", szDrive, szDir, szFname, szExt );
		 _snprintf_s( szPath, _MAX_PATH, _MAX_PATH, "%s%s%s%s", szDrive, szDir, szFname, szExt );
		 //_makepath_s( szPath, _MAX_PATH, szDrive, szDir, szFname, szExt  );		 
		 printf( "Ini file path final %s\n", szPath);		 
	} else
	{
		//Build ini file
		_snprintf_s( szPath, _MAX_PATH, _MAX_PATH, "%s%s%s%s", szmDrive, szmDir, szmFname, ".ini" );
		//_makepath_s(  szPath, _MAX_PATH, szmDrive, szmDir, szmFname, ".ini" );
		printf( "Ini file path final %s\n", szPath);
		_splitpath_s( szPath, szDrive, _MAX_DIR, szDir, _MAX_DIR, szFname, _MAX_FNAME, szExt,_MAX_EXT );
		printf( "Final ini file decomposed %s %s %s %s\n", szDrive, szDir, szFname, szExt );		
	}
	
	//Validate the .ini file
	if( ( fopen_s( &iniFile, szPath, "r" )) != 0 )
	{
      printf( "Initialization file '%s' not found\n", szPath );
	  returnCode = RET_ERROR;
	  exit( returnCode);
	}
	fclose( iniFile );

	if ( show )
	  printf( "\nInitalization file: %s\n", szPath );

	//Load the initialization parameters
	//The log file has to go first!
	//p0.99p
	//logfile and logtimestamp
	size = 1 + JSLGetProfileString( _service, "logtimestamp", "", buffer, bsize-pos, szPath );	
	logtimestamp = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "logtimestamp", logtimestamp );

	size = 1 + JSLGetProfileString( _service, "logfile", "", buffer, bsize-pos, szPath );	
	logfile = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "logfile", logfile );

	//Try logging - fail if file can't be opened
	if ( bDebug )
		logFileExists();

	if ( bDebug )
		logToFile( "Start loading params" );


	//Failure actions
	failureActions.dwResetPeriod = GetPrivateProfileInt( _service, "failureactions_resetperiod", 0, szPath );
	if ( show )
	  printf( "%s=%li\n", "failureactions_resetperiod", failureActions.dwResetPeriod );

	size = 1 + JSLGetProfileString( _service, "failureactions_rebootmsg", "", buffer, bsize-pos, szPath );	
	failureActions.lpRebootMsg = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "failureactions_rebootmsg", failureActions.lpRebootMsg );

	size = 1 + JSLGetProfileString( _service, "failureactions_command", "", buffer, bsize-pos, szPath );	
	failureActions.lpCommand = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "failureactions_command", failureActions.lpCommand );

	failureActions.cActions = GetPrivateProfileInt( _service, "failureactions_actions", 0, szPath );
	if ( show )
	  printf( "%s=%li\n", "failureactions_actions", failureActions.cActions );

	//Read list of failure actions
	failureActions.lpsaActions = NULL;
	if ( failureActions.cActions > 0 )
	{	
		fAction = malloc( sizeof(SC_ACTION)*failureActions.cActions);
		failureActions.lpsaActions = fAction;
		#pragma warning(disable:4018)
		for( i=0; i<failureActions.cActions; i++)
		#pragma warning(default:4018)
		{
			char name[16]; 
			sprintf_s(name, 128, "action%d_type", i);
			fAction[i].Type = GetPrivateProfileInt( _service, name, -1, szPath );
			//Detect and war about wrong non existant parameter
			if (fAction[i].Type == -1)
			{
				printf( "ERROR: Parameter %s not found\n", name );
				exit(1);
			}
			if ( show )
			  printf( "%s=%li\n", name, fAction[i].Type );
			
			sprintf_s(name, 128, "action%d_delay", i);
			fAction[i].Delay = GetPrivateProfileInt( _service, name, 0, szPath );
			if ( show )
			  printf( "%s=%li\n", name, fAction[i].Delay );
		}
	}

	//End failure actions

	//Java cmd line
	size = 1 + JSLGetProfileString( _java, "cmdline", "", buffer, bsize-pos, szPath );	
	szCmdLine = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "cmdline", szCmdLine );

	params = tokenize( szCmdLine, ' ' );
	cmdarg = NULL;	
	if ( params == 0 )
		szCmdLine = NULL;

	//param count
	if ( szCmdLine == NULL )
		params = GetPrivateProfileInt( _java, "params", 0, szPath );

	if (runAsService)
	{
	  nargc = params + STATIC_PARAMS;// Changed 24.06.1999, Heiner Jostkleigrewe
	}
	else
	{
	  nargc = params + 1 + 1; // Changed 16.05.2001, Erwin Vervondel //added +1 for -Dinifile parameter
	}
	nargv = malloc(( nargc ) * sizeof(LPTSTR));// Changed 24.06.1999, Heiner Jostkleigrewe

	*pargc = nargc;
    *pargv = nargv;
	nargv[currentParam++] = argv[0];

	//01.03.2001 Erwin Vervondel
	//Allow definition of jrepath in ini file
	size = 1 + JSLGetProfileString( _java, "jrepath", "", buffer, bsize-pos, szPath );	
	global_jrePath = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "jrepath", global_jrePath);

	//Jvmtype
	size = 1 + JSLGetProfileString( _java, "jvmtype", "" , buffer, bsize-pos, szPath );	
	global_jvmtype = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "jvmtype", global_jvmtype);	

	// Create dependencies buffer (a double null terminated array)
	szdependencies = malloc( 1024 );
	memset(szdependencies, 0, 1024);
	size = JSLGetProfileString( _service, "dependencies", "", szdependencies, 1023, szPath );	

	if ( show )
		printf( "%s=%s\n", "dependencies", szdependencies );
	
	for (i_p = 0; i_p < size; i_p++)
	{
		if (szdependencies[i_p] == ',') 
			szdependencies[i_p] = 0;

		
	}
	szdependencies[ size ] = 0;

	if ( show ) {
		size_t deppos = 0;
		for (i_p = 0; i_p < size+1; i_p++)
		{
			if (szdependencies[i_p] == 0) 
			{
				printf( "%s=%s\n", "dependency", szdependencies + deppos  );
				deppos = i_p+1;
			}
		}
	}
	//end 01.03.2001 Erwin Vervondel


	dwStartType = SERVICE_AUTO_START;
	//start type
	size = 1 + JSLGetProfileString( _service, "starttype", "auto", buffer, bsize-pos, szPath );
	if ( show )
	  printf( "%s=%s\n", "starttype", buffer);	

	if (strcmp(buffer, "boot") == 0 )
		dwStartType = SERVICE_BOOT_START;

	if (strcmp(buffer, "system") == 0 )
		dwStartType = SERVICE_SYSTEM_START;

	if (strcmp(buffer, "auto") == 0 )
		dwStartType = SERVICE_AUTO_START;

	if (strcmp(buffer, "demand") == 0 )
		dwStartType = SERVICE_DEMAND_START;

	if (strcmp(buffer, "disabled") == 0 )
		dwStartType = SERVICE_DISABLED;

	buffer += size;
	pos += size;
	

	szAccount = NULL;
	//Start account

	//szAccount = JSLGetProfileString( _service, "account", "", buffer, bsize-pos, szPath );
	
	size = 1 + JSLGetProfileString( _service, "account", "", buffer, bsize-pos, szPath );
	if ( buffer[0] != 0 )
		szAccount = buffer;
    else
        szAccount = 0;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "account", szAccount);	


	szPwd = NULL;
	//Start password
	size = 1 + JSLGetProfileString( _service, "password", "", buffer, bsize-pos, szPath );
	if ( buffer[0] != 0 )
		szPwd = buffer;
    else
        szPwd = 0;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "password", szPwd);	

	szLoadOrderGroup = NULL;
	//Load order group
	size = 1 + JSLGetProfileString( _service, "loadordergroup", "", buffer, bsize-pos, szPath );	
	if ( buffer[0] != 0 )
		szLoadOrderGroup = buffer;
    else
        szLoadOrderGroup = 0;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "loadordergroup", szLoadOrderGroup);

	//Working directory
	size = 1 + JSLGetProfileString( _java, "wrkdir", "", buffer, bsize-pos, szPath );	
	if ( buffer[0] != 0 )
	// 30.12.2008: Begin GCollin
    // Support for '.' in working dir, replaced with .ini directory
    {
		if( buffer[0] == '.')
		{
			size = size - 1 + strlen(szDrive)+strlen(szDir);
			global_wrkdir = malloc(size); 
			strcpy_s(global_wrkdir, size, szDrive);
			strcat_s(global_wrkdir, size, szDir);
			if (buffer[1] == '\\' )
				strcat_s(global_wrkdir, size, buffer+2);
			if ( bsize-pos >= size )
				strcpy_s(buffer, bsize-pos, global_wrkdir);
			if ( global_wrkdir )
				free(global_wrkdir);			
		}
		global_wrkdir = buffer;		
        // 30.12.2008: End GCollin 
	}
	else
	    global_wrkdir = 0;

	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "wrkdir", global_wrkdir);

	//Application name
	size = 1 + JSLGetProfileString( _service, "appname", "appname", buffer, bsize-pos, szPath );	
	szappname = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "appname", szappname );

	//Service name
	size = 1 + JSLGetProfileString( _service, "servicename", "servicename", buffer, bsize-pos, szPath );	
	szservicename = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "servicename", szservicename );

	//Displayname
	size = 1 + JSLGetProfileString( _service, "displayname", "displayname", buffer, bsize-pos, szPath );	
	szdisplayname = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "displayname", szdisplayname );

	//Description
	size = 1 + JSLGetProfileString( _service, "servicedescription", szdisplayname, buffer, bsize-pos, szPath );	
	szservicedescription = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "servicedescription", szservicedescription );

	//p0.99
	//stdout and stderr redirect
	size = 1 + JSLGetProfileString( _service, "stdout", "", buffer, bsize-pos, szPath );	
	stdoutfile = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "stdout", stdoutfile );

	size = 1 + JSLGetProfileString( _service, "stderr", "", buffer, bsize-pos, szPath );	
	stderrfile = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "stderr", stderrfile );

	// 0.99d - 19.02.2003 Urs Bloechlinger
	// overwrite or append
	size = 1 + JSLGetProfileString( _service, "stdoutappend", "no", buffer, bsize-pos, szPath );	
	szStdOutAppend = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "stdoutappend", szStdOutAppend );

	stdOutAppend = boolVal( szStdOutAppend );

	size = 1 + JSLGetProfileString( _service, "stderrappend", "no", buffer, bsize-pos, szPath );	
	szStdErrAppend = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "stderrappend", szStdErrAppend );

	stdErrAppend = boolVal( szStdErrAppend );
	// end 0.99d
	

	//System.out and System.err redirect
	size = 1 + JSLGetProfileString( _service, "systemout", "", buffer, bsize-pos, szPath );	
	systemOut = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "systemout", systemOut );

	size = 1 + JSLGetProfileString( _service, "systemerr", "", buffer, bsize-pos, szPath );	
	systemErr = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "systemerr", systemErr );

	size = 1 + JSLGetProfileString( _service, "systemoutappend", "no", buffer, bsize-pos, szPath );	
	szSystemOutAppend = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "systemoutappend", szSystemOutAppend );

	systemOutAppend = boolVal( szSystemOutAppend );

	size = 1 + JSLGetProfileString( _service, "systemerrappend", "no", buffer, bsize-pos, szPath );	
	szSystemErrAppend = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "systemerrappend", szSystemErrAppend );

	systemErrAppend = boolVal( szSystemErrAppend );

	
	//interact with desktop
	size = 1 + JSLGetProfileString( _service, "interactwithdesktop", "no", buffer, bsize-pos, szPath );	
	szinteractwithdesktop = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "interactwithdesktop", szinteractwithdesktop );

	interactwithdesktop = boolVal( szinteractwithdesktop );

	//Exception error code
	exceptionErrorCode = GetPrivateProfileInt( _service, "exceptionerrorcode", exceptionErrorCode,  szPath );	
 
	if ( show )
	  printf( "%s=%li\n", "exceptionerrorcode", exceptionErrorCode );

	//Behaviour for non zero exit code
	size = 1 + JSLGetProfileString( _service, "onexiterror", "ignore", buffer, bsize-pos, szPath );	
	onExitError = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "onexiterror", onExitError );

	//Behaviour on main thread exit
	size = 1 + JSLGetProfileString( _service, "reportservicestoppedonmainthreadexit", "no", buffer, bsize-pos, szPath );	
	szreportservicestoppedonmainthreadexit = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "reportservicestoppedonmainthreadexit", szreportservicestoppedonmainthreadexit );

	breportservicestoppedonmainthreadexit = boolVal( szreportservicestoppedonmainthreadexit );

	//Class to use for stopping the service
	size = 1 + JSLGetProfileString( _service, "stopclass", "", buffer, bsize-pos, szPath );	
	stopClass = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "stopclass", stopClass );

	//Method to use for stopping the service
	size = 1 + JSLGetProfileString( _service, "stopmethod", "", buffer, bsize-pos, szPath );	
	stopMethod = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "stopmethod", stopMethod );

	//Signature to use for stopping the service
	size = 1 + JSLGetProfileString( _service, "stopsignature", "", buffer, bsize-pos, szPath );	
	stopSignature = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "stopsignature", stopSignature );

	//Parameters passed when stopping the service
	size = 1 + JSLGetProfileString( _service, "stopparams", "", buffer, bsize-pos, szPath );	
	stmp = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "stopparams", stmp );

	stopParams = stringToArray( stmp, ' ' );

	//Class to use for pausing the service
	size = 1 + JSLGetProfileString( _service, "pauseclass", "", buffer, bsize-pos, szPath );	
	pauseClass = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "pauseclass", pauseClass );

	//Method to use for pausing the service
	size = 1 + JSLGetProfileString( _service, "pausemethod", "", buffer, bsize-pos, szPath );	
	pauseMethod = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "pausemethod", pauseMethod );

	//Signature to use for pausing the service
	size = 1 + JSLGetProfileString( _service, "pausesignature", "", buffer, bsize-pos, szPath );	
	pauseSignature = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "pausesignature", pauseSignature );

	//Parameters passed when pausing the service
	size = 1 + JSLGetProfileString( _service, "pauseparams", "", buffer, bsize-pos, szPath );	
	stmp = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "pauseparams", stmp );

	pauseParams = stringToArray( stmp,' ' );



	//Class to use for continueing the service
	size = 1 + JSLGetProfileString( _service, "contclass", "", buffer, bsize-pos, szPath );	
	contClass = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "contclass", contClass );

	//Method to use for continueing the service
	size = 1 + JSLGetProfileString( _service, "contmethod", "", buffer, bsize-pos, szPath );	
	contMethod = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "contmethod", contMethod );

	//Signature to use for continueing the service
	size = 1 + JSLGetProfileString( _service, "contsignature", "", buffer, bsize-pos, szPath );	
	contSignature = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "contsignature", contSignature );

	//Parameters passed when the service is continued
	size = 1 + JSLGetProfileString( _service, "contparams", "", buffer, bsize-pos, szPath );	
	stmp = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "contparams", stmp );

	contParams = stringToArray( stmp,' ' );


	//Class to use for confirming service running
	size = 1 + JSLGetProfileString( _service, "confirmrunclass", "", buffer, bsize-pos, szPath );	
	confirmrunClass = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "confirmrunclass", confirmrunClass );

	//Method to use for confirming service running
	size = 1 + JSLGetProfileString( _service, "confirmrunmethod", "", buffer, bsize-pos, szPath );	
	confirmrunMethod = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "confirmrunmethod", confirmrunMethod );

	//Signature to use for confirming service running
	size = 1 + JSLGetProfileString( _service, "confirmrunsignature", "", buffer, bsize-pos, szPath );	
	confirmrunSignature = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "confirmrunsignature", confirmrunSignature );

	//Parameters passed when confirming service running
	size = 1 + JSLGetProfileString( _service, "confirmrunparams", "", buffer, bsize-pos, szPath );	
	stmp = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "confirmrunparams", stmp );

	confirmrunParams = stringToArray( stmp,' ' );



	//Class to use for premain call
	size = 1 + JSLGetProfileString( _service, "premainclass", "", buffer, bsize-pos, szPath );	
	premainClass = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "premainclass", premainClass );

	//Method to use for premain call
	size = 1 + JSLGetProfileString( _service, "premainmethod", "", buffer, bsize-pos, szPath );	
	premainMethod = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "premainmethod", premainMethod );

	//Signature to use for premain call
	size = 1 + JSLGetProfileString( _service, "premainsignature", "", buffer, bsize-pos, szPath );	
	premainSignature = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "premainsignature", premainSignature );

	//Parameters passed when premain is called
	size = 1 + JSLGetProfileString( _service, "premainparams", "", buffer, bsize-pos, szPath );	
	stmp = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "premainparams", stmp );

	premainParams = stringToArray( stmp, ' ' );


	//Stop port
	stopport = GetPrivateProfileInt( _service, "stopport", stopport,  szPath );	
 
	if ( show )
	  printf( "%s=%li\n", "stopport", stopport );

	//Stop port
	startdelay = GetPrivateProfileInt( _service, "startdelay", startdelay,  szPath );	
 
	if ( show )
	  printf( "%s=%li\n", "startdelay", startdelay );
	

	//Using a console handler
	size = 1 + JSLGetProfileString( _service, "useconsolehandler", "yes", buffer, bsize-pos, szPath );	
	szconsolehandler = buffer;
	buffer += size;
	pos += size;

	useConsoleHandler = boolVal( szconsolehandler );

	if ( show )
	  printf( "%s=%s\n", "useconsolehandler", szconsolehandler );

	//Signature to use for stopping the service
	size = 1 + JSLGetProfileString( _service, "path", "", buffer, bsize-pos, szPath );	
	path = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "path", path );

	if ( strlen( path ) != 0 )
		SetEnvironmentVariable( "PATH", path );

	//Executable to run the service from 
	size = 1 + JSLGetProfileString( _service, "modulepath", szModulePath, buffer, bsize-pos, szPath );	
	szModulePath = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "modulepath", szModulePath );

	if ( bDebug )
		logToFile( "Loaded module path" );		

	//Export variables
	size = 1 + JSLGetProfileString( _defines, "export", NULL, buffer, bsize-pos, szPath );	
	export = buffer;
	buffer += size;
	pos += size;
	if ( show )
	  printf( "%s=%s\n", "export", export );

	//Tokenize export variable list
	exportParams = stringToArray( export, ',' );
	for( i=0; exportParams[i]!=NULL; i++)
	{
		size = 1 + JSLGetProfileString( _defines, exportParams[i], NULL, buffer, bsize-pos, szPath );			
		SetEnvironmentVariable( exportParams[i], buffer );
		pos += size;
		if ( show )
			printf( "export %s=%s\n", exportParams[i], buffer );

		buffer += size;
	}


	//Read first param ...
	if ( szCmdLine == NULL )
	{
		size = 1 + JSLGetProfileString( _java, _param, "", buffer, bsize-pos, szPath );	
		stmp = buffer;		
		buffer += size;
		pos += size;
	} else {
		cmdarg = next_token( szCmdLine, cmdarg );
		stmp = cmdarg;
	}			

	//and check for -classic -hotspot -server -client params
	if (strcmp(stmp, "-classic") == 0 || strcmp(stmp, "-server") == 0 || strcmp(stmp, "-hotspot") == 0 || strcmp(stmp, "-client") == 0 )
	{
	  startParam = 1;
	  _snprintf_s( commandLine, bsize-cpos, bsize-cpos, "%s ", stmp );
	  nargv[currentParam++] = stmp;
	  commandLine += size;
	  cpos += size;	  
	  pos += size;
	  if ( show && szCmdLine == NULL )
		printf( "%s=%s\n", _param, stmp );
	  else
	  {
		printf( "%s\n", stmp );		
	  }
	  printf( "%s", commandLine );
	} else {
		//Start again 
		cmdarg = NULL;
	}
			

	if ( bDebug )
		logToFile( "After JVM type check" );

	//16.05.01 Erwin Vervondel
	//only set 'service' options if application is run as service
	if (runAsService)
	{		
		//16.7.99 Michael Rschter
		//Made string formatting more robust
		#ifdef VC6
		size = 1 + _snprintf( buffer, bsize-pos, "-Dservice.stop.port=%li", stopport );
		#else
		size = 1 + _snprintf_s( buffer, bsize-pos, bsize-pos, "-Dservice.stop.port=%li", stopport );
		#endif
		_snprintf_s( commandLine, bsize-cpos, bsize-cpos, "%s ", buffer );
		commandLine += size;
		cpos += size;
		nargv[currentParam++] = buffer;	
		buffer += size;
		pos += size;	

		printf( "%s", commandLine );

		//New 24.06.1999, Heiner Jostkleigrewe
		//16.7.99 Michael Rschter
		//Made string formatting more robust
			
		pathformat = "-Dservice.path=%s%s";
		cmdpathformat = "-Dservice.path=%s%s ";
		if (  strchr( szDir, ' ' ) )
			cmdpathformat = "\"-Dservice.path=%s%s\" ";		
		
		#ifdef VC6
		size = 1 + _snprintf( buffer, bsize-pos, pathformat, szDrive, szDir );
		#else
		size = 1 + _snprintf_s( buffer, bsize-pos, bsize-pos, pathformat, szDrive, szDir );
		#endif

		nargv[currentParam++] = buffer;
		buffer += size;
		pos += size;
		
		#ifdef VC6
		size = _snprintf( commandLine, bsize-cpos, cmdpathformat, szDrive, szDir );
		#else
		size = _snprintf_s( commandLine, bsize-cpos, bsize-cpos, cmdpathformat, szDrive, szDir );
		#endif
		commandLine += size;
		cpos += size;
		
	
		pathformat = "-Dservice.name=%s";
		cmdpathformat = "-Dservice.name=%s ";
		if ( strchr( szservicename, ' ' )  )
			cmdpathformat = "\"-Dservice.name=%s\" ";
			
		size = 1 + _snprintf_s( buffer, bsize-pos, bsize-pos, pathformat, szservicename );
		nargv[currentParam++] = buffer;
		buffer += size;
		pos += size;

		size = _snprintf_s( commandLine, bsize-cpos, bsize-cpos, cmdpathformat, szservicename );
		commandLine += size;
		cpos += size;
		
	
	}	
	//Add full path to my own ini file. This is always useful not only for a service.
	//Mainly used for the pre main method hooks
	//Detect spaces in path
	
	if ( bDebug )
		logToFile( "After service options" );

	pathformat = "-Dservice.inifile=%s";
	cmdpathformat = "-Dservice.inifile=%s ";
	if (  strchr( szPath, ' ' ) )
		cmdpathformat = "\"-Dservice.inifile=%s\" ";
	
	
	size = 1 + _snprintf_s( buffer, bsize-pos, bsize-pos, pathformat, szPath );
	nargv[currentParam++] = buffer;	
	buffer += size;
	pos += size;

	size = _snprintf_s( commandLine, bsize-cpos, bsize-cpos, cmdpathformat, szPath );
	commandLine += size;
	cpos += size;		
	
	if ( bDebug )
		logToFile( "After ini file options" );

	if ( bDebug )
		logToFile( "Params:" );
/*
	if (show )
	for ( i=0; i<params; i++ )
	{
		cmdarg = next_token( szCmdLine, cmdarg);
		printf( "%s\n", cmdarg );
	}
*/

	for( i=startParam; i<params; i++)
	{
		_param[5] = 48 + i / 10;
		_param[6] = 48 + i % 10;

		if ( szCmdLine == NULL )
		{
			size = 1+JSLGetProfileString( _java, _param, "", buffer, bsize-pos, szPath );	
			nargv[ currentParam++ ] = buffer;
			buffer += size;
			pos += size;
			if ( show )
				printf( "%s=%s\n", _param, nargv[ currentParam - 1  ] );
		} else {
			cmdarg = next_token( szCmdLine, cmdarg);
			nargv[ currentParam++ ] = cmdarg;
			if ( show )
				printf( "%s\n", cmdarg );
		}
				

		//try to change work directory
		if( NULL != global_wrkdir  ){
			if( 0 != _chdir(global_wrkdir)){
				AddToMessageLog(TEXT("Unable to change working directory."));
			}
		}

		if ( isclasspath )
		{
			nargv[currentParam-1] = (char*)JLI_WildcardExpandClasspath(nargv[currentParam-1]);
			isclasspath = 0;
			if ( show )
				printf( "%s=%s\n", "Expanded classpath", nargv[ currentParam - 1  ] );
		} else {
			if (strcmp(nargv[currentParam-1],"-cp")==0 || strcmp(nargv[currentParam-1],"-classpath")==0 )
				isclasspath = 1;
		}
				
		//printf( "%li %li ", bsize, cpos);
		_snprintf_s( commandLine, bsize-cpos, bsize-cpos, "%s ", nargv[currentParam-1] );
		size = 1+strlen(nargv[currentParam-1]);
		commandLine += size;
		cpos += size;

		if ( bDebug )
			logToFile( nargv[ currentParam - 1  ] );		
		
	}	

	if ( show )
	  printf( "Java command line:\njava %s\n", commandLineStart );	


	if ( bDebug )
		logToFile( commandLineStart );
}

LPTSTR* stringToArray(char* s, char delim )
{
	int size;
	LPTSTR* array = NULL;
	int i;
	LPTSTR token = NULL;
	size = tokenize(s, delim );
	if ( s == 0 )
		return array;
	
	array = malloc( (size+1) * sizeof(LPTSTR) );
	array[size] = NULL;

	for( i=0; i<size; i++)
	{
		token = next_token(s,token);
		array[i] = token;
	}
	return array;
}


int tokenize( char* s, char delim )
{
	int count = 0;
	int state = 0; //0=looking for next start; 1=looking for end(space or zero); 2=looking for end(quote or zero)
	
	if ( s == NULL )
		return 0;
	
	while ( *s != 0 )
	{
		//Look for next token start
		if ( state == 0 )
		{
			//spaces are nulled
			while( *s == ' ')
				*(s++) = 0;
			
			//quotes are nulled and transfer to state 2
			if ( *s== '\"' )
			{
				*(s++) = 0;
				state = 2;
			} else {
				state = 1;
			}
			if ( *s != 0 )
				count++;
		}
		if ( state == 1 )
		{
			//look for delimiter or zero
			while( *s != delim && *s!= 0)
				s++;
			//Null delimiter and move on
			if ( *s != 0 )
				*(s++) = 0;
			//Do nothing if 0 was found
			state = 0;
		}
		if ( state == 2 )
		{
			//look for quote or zero
			while( *s != '\"' && *s!= 0)
				s++;
			//Null space and move on
			if ( *s != 0 )
				*(s++) = 0;
			//Do nothing if 0 was found
			state = 0;
		}
	}
		
	return count;
}

LPTSTR next_token( char* s, LPTSTR token )
{
	if ( token != NULL )
		s = token + strlen(token);
		
	while ( *s == 0 )
		s++;
	
	//printf( "token string: '%s'\n", s );
	return s;
}

void getIniFile( LPTSTR szPath )
{
	int i;
    if ( GetModuleFileName( NULL, szPath, 512 ) == 0)
		AddToMessageLog(TEXT("Could not get module name, so in consequence could not locate ini file."));	
	//construct the ini file name 	
	
	for( i=0; szPath[i] != 0; i++ );
	szPath[i-3] = 'i';
	szPath[i-2] = 'n';
	szPath[i-1] = 'i';
}


size_t JSLGetProfileStringR( LPTSTR section, LPTSTR name, LPTSTR _default, LPTSTR buffer, size_t bsize, LPTSTR path, int depth )
{
	size_t size = bsize;
	LPTSTR tmpbuf = NULL;
	LPTSTR start;
	LPTSTR stop;
	LPTSTR buf;
	LPTSTR _defines = "defines";
	size_t tmpsize = 0;
	size_t recursion = 1;
	
	#pragma warning(disable:4267)
	GetPrivateProfileString( section, name, _default, buffer, bsize, path );
	#pragma warning(default:4267)

	if ( bDebug )
		printf( "Ini file: %s = %s\n" , name, buffer );

	buf = buffer;
	start = strchr( buf,'%');

	//printf( "Parsing %s\n", buf );

	//no buffer if there is no substitution
	if ( start  )
	{
		//printf( "found %% \n");
		tmpbuf = malloc( bsize );
		tmpbuf[0] = 0;
	}

	while ( start)
	{
		//printf( "A %s\n", buf );
		//printf( "B %s\n", tmpbuf );

		stop = strchr( start+1, '%' );
		if ( stop )
		{
			//Deliminate variable with zeros (replacing the %)
			start[0] = 0;
			stop[0] = 0;
			
			//printf( "T %s\n", start+1 );
			if ( size >= strlen( buf ) )
			{
				strcat_s( tmpbuf, bsize, buf );
				size -= strlen(buf);
			}
			//Convert %% in to single %
			if ( stop - start == 1 )
			{
				if ( size >= 1 )
				{
					strcat_s( tmpbuf, bsize, "%" );
					size--;
				}
			} else
			{
				//Look for the value in the defines section first
				//Prevent endless recursion				
				//Detects indirect recursion by limiting depth of recursion
				if ( 0 == strcmp( section, _defines ) && depth>=32)  
					recursion = 0;
				//Special case. If a variable in the define section contains a reference to itself, 
				//we take this to mean it is referencing an environment variable with same name
				//e.g.  PATH=%PATH%;c:\temp
				//Obviously the above is useful in many situations
				if ( 0 == strcmp( section, _defines ) && 0 == strcmp( start+1, name ) )  
					recursion = 0;
				//Now check for the variable definition in the variable list ....
				if ( recursion )
					tmpsize = JSLGetProfileStringR( _defines, start+1, "", tmpbuf + strlen(tmpbuf), size, path, depth+1 );
				//.. if not found look for environement variables
				if ( bDebug )
					printf( "After subsitution: %s = %s\n" , name, tmpbuf + strlen(tmpbuf) );

				#pragma warning(disable:4267)
				if ( tmpsize == 0 )
				{
					tmpsize += GetEnvironmentVariable( start+1, tmpbuf + strlen(tmpbuf) , size );
					if ( bDebug )
						printf( "From environment: %s = %s\n" , start+1, tmpbuf );
					//If not found in environment fall back to registry
					if ( tmpsize == 0 )
					{
						printf( "Failed to find in environment %s. Looking up registry\n", start+1 );
						tmpsize += GetRegistryValue( "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment", start+1 , tmpbuf + strlen(tmpbuf), size );
					}
				}
				#pragma warning(default:4267)

				size -= tmpsize;
			}
			buf = stop + 1;
			start = strchr( buf,'%');			

		} else
		{
			start = NULL;
		}
	}	

	if ( tmpbuf)
	{
		//printf( "C %s\n", buf );
		//printf( "D %s\n", tmpbuf );

		strcat_s( tmpbuf, bsize, buf );
		strcpy_s( buffer, bsize, tmpbuf );
		free( tmpbuf );
	}

	//printf( "E %s\n", buffer );

	if ( bDebug )
		printf( "Finally:  %s = %s\n" , name, buffer );

	//printf( "End parsing\n" );
	return strlen( buffer );
}

size_t JSLGetProfileString( LPTSTR section, LPTSTR name, LPTSTR _default, LPTSTR buffer, size_t bsize, LPTSTR path )
{
	return JSLGetProfileStringR( section, name, _default, buffer, bsize, path, 0 );
}

void getLogFile( LPTSTR szPath )
{
	size_t i;
	char dateTime[32];
	char modulePath[512];

	if ( strlen(logfile) == 0 )
	{
		if ( GetModuleFileName( NULL, modulePath, 512 ) == 0)
			AddToMessageLog(TEXT("Could not get module name, so in consequence could not locate log file."));	
		strcpy_s( szPath, 512, modulePath );
		i = strlen( szPath )-3;
		szPath[i] = 0;
		if ( strlen(logtimestamp) != 0)
		{
			dateTimeToString ( dateTime, logtimestamp );
			strcat_s( szPath, 512, dateTime );
			strcat_s( szPath, 512, "." );
		}
		strcat_s( szPath, 512, "log" );
	} else {
		strcat_s( szPath, 512, logfile );
		timestampFile( szPath );
	}
}

void timestampFile( LPTSTR szPath )
{
	char dateTime[32];
	char ext[4];
	size_t i;

	if ( strlen(logtimestamp) != 0)
	{
		dateTimeToString ( dateTime, logtimestamp );
		i = strlen( szPath )-3;
		strcpy_s( ext, 4, szPath+i );
		szPath[i] = 0;
		strcat_s( szPath, 512, dateTime );
		strcat_s( szPath, 512, "." );
		strcat_s( szPath, 512, ext );
	}			
}

/**
  * Log to file
*/
void logToFile( LPTSTR s )
{	
	TCHAR szPath[512] = "";
	FILE* f;
	char dateTime[20];
	
	dateTimeToString (dateTime, "%Y-%m-%d %H:%M:%S");

	EnterCriticalSection( &csLog );
	getLogFile( szPath );

	fopen_s( &f, szPath, "a+" );

	//fprintf( f, ":%d:%s\n" , theTime, s );	
	fprintf( f, "%s: " , dateTime );
	fprintf( stdout, "%s: " , dateTime );
	fprintf( f, "%s\n" , s );
	fprintf( stdout, "%s\n" , s );
	fclose( f );
	LeaveCriticalSection( &csLog );
}

void logToFileD( long d )
{	
	TCHAR szPath[512]  = "";
	FILE* f;
	char dateTime[20];
	
	dateTimeToString (dateTime, "%Y-%m-%d %H:%M:%S");

	EnterCriticalSection( &csLog );
	getLogFile( szPath );
	fopen_s( &f, szPath, "a+" );	
	fprintf( f, "%s: %d\n" , dateTime, d );
	fclose( f );
	LeaveCriticalSection( &csLog );
}

void logFileExists()
{
	TCHAR szPath[512] = "";
	getLogFile( szPath );
	fileExists( szPath );
}

void fileExists( TCHAR szPath[512] )
{	
	FILE* f;
	errno_t fopen_err;
	char dateTime[20];
	
	dateTimeToString (dateTime, "%Y-%m-%d %H:%M:%S");

	EnterCriticalSection( &csLog );
	fopen_err = fopen_s( &f, szPath, "a+" );	
	//Check if we can log to log file
	if ( fopen_err != 0 )
	{
		printf( "Could not open file.\n" );
		printf( "File: %s\n", szPath );
		AddToMessageLog(TEXT("Could not open file."));	
		AddToMessageLog( szPath );	
		exit( fopen_err );
	}

	fprintf( f, "%s: Test write file\n" , dateTime );
	fclose( f );
	LeaveCriticalSection( &csLog );
}




// New 24.06.1999, Heiner Jostkleigrewe
void getIniDir( LPTSTR szPath , LPTSTR szDrive, size_t driveSize, LPTSTR szDir, size_t dirSize)
{
   TCHAR fname[_MAX_FNAME];
   TCHAR ext[_MAX_EXT];
	#ifdef VC6
   _splitpath( szPath, szDrive, szDir, fname, ext );
	#else
   _splitpath_s( szPath, szDrive, driveSize, szDir, dirSize, fname, _MAX_FNAME, ext,_MAX_EXT );
	#endif


}
// New Ende

/**
  * Perform service initialization
 */
void init()
{
	// register a service control handler
    sshStatusHandle = RegisterServiceCtrlHandler( TEXT(SZSERVICENAME), service_ctrl);

}

//
//  FUNCTION: service_main
//
//  PURPOSE: To perform actual initialization of the service
//
//  PARAMETERS:
//    dwArgc   - number of command line arguments
//    lpszArgv - array of command line arguments
//
//  RETURN VALUE:
//    none
//
//  COMMENTS:
//    This routine performs the service initialization and then calls
//    the user defined ServiceStart() routine to perform majority
//    of the work.
//
void WINAPI service_main(DWORD dwArgc, LPTSTR *lpszArgv)
{
	if ( bDebug )
		logToFile( "service main called" );
	
    init();

    if (!sshStatusHandle)
        goto cleanup;

    // Some 
    ssStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
    ssStatus.dwServiceSpecificExitCode = 0;

	if ( bDebug )
		logToFile( "OK 1" );

    // report the status to the service control manager.
    if (!ReportStatusToSCMgr(
		SERVICE_START_PENDING, // service state
        NO_ERROR,              // exit code
        60000))                 // wait hint
        goto cleanup;
	
	
	//p0.99
	prepare();
    ServiceStart( global_argc, global_argv );

cleanup:

	if ( bDebug )
		logToFile( "service cleanup" );
	

    // try to report the stopped status to the service control manager.
    if (sshStatusHandle)
        (VOID)ReportStatusToSCMgr(
                            SERVICE_STOPPED,
                            dwErr,
                            0);

	if ( bDebug )
		logToFile( "service exiting" );
	

    return;
}


//
//  FUNCTION: service_ctrl
//
//  PURPOSE: This function is called by the SCM whenever
//           ControlService() is called on this service.
//
//  PARAMETERS:
//    dwCtrlCode - type of control requested
//
//  RETURN VALUE:
//    none
//
//  COMMENTS:
//
VOID WINAPI service_ctrl(DWORD dwCtrlCode)
{
	if ( bDebug )
		logToFile( "service control call entered" );
    // Handle the requested control code.
    //
    switch(dwCtrlCode)
    {
        // Stop the service.
        //
        // SERVICE_STOP_PENDING should be reported before
        // setting the Stop Event - hServerStopEvent - in
        // ServiceStop().  This avoids a race condition
        // which may result in a 1053 - The Service did not respond...
        // error.
        case SERVICE_CONTROL_STOP:
			if ( bDebug )
				logToFile( "SERVICE_CONTROL_STOP" );
		case SERVICE_CONTROL_SHUTDOWN:
			if ( bDebug )
				logToFile( "SERVICE_CONTROL_SHUTDOWN" );
            ReportStatusToSCMgr(SERVICE_STOP_PENDING, NO_ERROR, 60000);			
            ServiceStop();	
			return;
			
		case SERVICE_CONTROL_PAUSE: 
			if ( bDebug )
				logToFile( "SERVICE_CONTROL_PAUSE" );
			ServicePause();
            return; 

		case SERVICE_CONTROL_CONTINUE: 			 
			if ( bDebug )
				logToFile( "SERVICE_CONTROL_CONTINUE" );
			ReportStatusToSCMgr(SERVICE_CONTINUE_PENDING, NO_ERROR, 60000);
			ServiceContinue();
            return; 

        // Update the service status.
        //
        case SERVICE_CONTROL_INTERROGATE:
			if ( bDebug )
				logToFile( "SERVICE_CONTROL_INTERROGATE" );
            break;

        // invalid control code
        //
        default:
			if ( bDebug )
				logToFile( "Unknown control code" );
            break;

    }

    ReportStatusToSCMgr(ssStatus.dwCurrentState, NO_ERROR, 0);
}



//
//  FUNCTION: ReportStatusToSCMgr()
//
//  PURPOSE: Sets the current status of the service and
//           reports it to the Service Control Manager
//
//  PARAMETERS:
//    dwCurrentState - the state of the service
//    dwWin32ExitCode - error code to report
//    dwWaitHint - worst case estimate to next checkpoint
//
//  RETURN VALUE:
//    TRUE  - success
//    FALSE - failure
//
//  COMMENTS:
//
BOOL ReportStatusToSCMgr(DWORD dwCurrentState,
                         DWORD dwWin32ExitCode,
                         DWORD dwWaitHint)
{
    static DWORD dwCheckPoint = 1;
    BOOL fResult = TRUE;
	returnCode = dwWin32ExitCode;

    if ( !bCommandLine ) // when debugging we don't report to the SCM
    {
        if (dwCurrentState == SERVICE_START_PENDING)
            ssStatus.dwControlsAccepted = 0;
        else
		{
            ssStatus.dwControlsAccepted = SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_SHUTDOWN;
			if ( strlen( pauseClass ) && strlen( pauseMethod ) && strlen( pauseSignature ) && 
				 strlen( contClass ) && strlen( contMethod ) && strlen( contSignature ) )
			{
				ssStatus.dwControlsAccepted |= SERVICE_ACCEPT_PAUSE_CONTINUE;
			}
		}
        ssStatus.dwCurrentState = dwCurrentState;

		//p0.99
		if ( dwCurrentState == SERVICE_STOPPED && dwWin32ExitCode != 0 && strcmp( onExitError, "reportcode" )==0 )
		{
			ssStatus.dwWin32ExitCode = ERROR_SERVICE_SPECIFIC_ERROR;
			ssStatus.dwServiceSpecificExitCode = dwWin32ExitCode;
        } else
			ssStatus.dwWin32ExitCode = 0;

		
		if ( dwCurrentState == SERVICE_STOPPED && strcmp( onExitError, "fatal" )==0 && dwWin32ExitCode != 0 )
		{
			//printf( "Fatal exit code %d", dwWin32ExitCode );			
			exit( dwWin32ExitCode );
		}


        ssStatus.dwWaitHint = dwWaitHint;

        if ( ( dwCurrentState == SERVICE_RUNNING ) ||
             ( dwCurrentState == SERVICE_STOPPED ) )
            ssStatus.dwCheckPoint = 0;
        else
            ssStatus.dwCheckPoint = dwCheckPoint++;


        // Report the status of the service to the service control manager.
        //
        if (!(fResult = SetServiceStatus( sshStatusHandle, &ssStatus))) {
            AddToMessageLog(TEXT("SetServiceStatus"));
        }
    }
    return fResult;
}

//
//  FUNCTION: AddToMessageLog(LPTSTR lpszMsg)
//
//  PURPOSE: Allows any thread to log an error message
//
//  PARAMETERS:
//    lpszMsg - text for message
//
//  RETURN VALUE:
//    none
//
//  COMMENTS:
//
VOID AddToMessageLog(LPTSTR lpszMsg)
{
    TCHAR   szMsg[256];
    HANDLE  hEventSource;
    LPTSTR  lpszStrings[2];


    if ( !bDebug )
    {
        dwErr = GetLastError();

        // Use event logging to log the error.
        //
        hEventSource = RegisterEventSource(NULL, TEXT(SZSERVICENAME));

		#ifdef VC6
        _stprintf(szMsg, TEXT("%s error: %d"), TEXT(SZSERVICENAME), dwErr);
		#else
		_stprintf_s(szMsg, 256, TEXT("%s error: %d"), TEXT(SZSERVICENAME), dwErr);
		#endif

        lpszStrings[0] = szMsg;
        lpszStrings[1] = lpszMsg;

        if (hEventSource != NULL) {
            ReportEvent(hEventSource, // handle of event source
                EVENTLOG_ERROR_TYPE,  // event type
                0,                    // event category
                0,                    // event ID
                NULL,                 // current user's SID
                2,                    // strings in lpszStrings
                0,                    // no bytes of raw data
                lpszStrings,          // array of error strings
                NULL);                // no raw data

            (VOID) DeregisterEventSource(hEventSource);
        }
    }
}

size_t GetRegistryValue( LPTSTR keyname, LPTSTR entry, LPTSTR value, size_t valueSize )
{
	HKEY key, subkey;	
	DWORD serviceType = 0x00000010;
	DWORD size;
	DWORD valueType;

	if ( 0 != RegOpenKeyEx(HKEY_LOCAL_MACHINE, keyname, 0, KEY_READ, &subkey ) )
		printf( "Failed to open registry key %s\n", keyname );
	key = subkey;

	//Reading the value
	#pragma warning(disable:4267)
	size = valueSize;
	#pragma warning(default:4267)
	if ( 0 != RegQueryValueEx(subkey, entry, 0, &valueType, value, &size) )
		printf( "Failed to read registry entry %s\\%s %s\n", keyname, entry, GetLastErrorText( szErr, 256) );
	
	//RegCloseKey(subkey);
	RegCloseKey(key);

	valueSize = size;
	return valueSize;
}

void CmdAddServiceParameterRegistry()
{
	HKEY key, subkey;
	LPTSTR keyname = "SYSTEM\\CurrentControlSet\\Services";
	DWORD serviceType = 0x00000010;
	//DWORD size;
	//DWORD valueType;

	if ( 0 != RegOpenKeyEx(HKEY_LOCAL_MACHINE, keyname, 0, KEY_READ, &subkey ) )
		printf( "Failed to open registry key %s\n", keyname );
	key = subkey;

	keyname = szservicename;
	if ( 0 != RegOpenKeyEx(key, keyname, 0, KEY_ALL_ACCESS, &subkey ) )
		printf( "Failed to open registry key %s\n", keyname );

	//Setting the service desscription
	keyname = "Description";
	#pragma warning(disable:4267)
	if ( 0 != RegSetValueEx(subkey, keyname, 0, REG_SZ, szservicedescription, strlen(szservicedescription) ) )
		printf( "Failed to set registry value %s=%s %s\n", keyname,szservicedescription, GetLastErrorText( szErr, 256) );
	#pragma warning(default:4267)

	//Setting the interact with desktop flag	
	//Obsolete, we handle this from the CreateService Call now
	/*
	keyname = "Type";
	if ( 0 != RegQueryValueEx(subkey, keyname, 0, &valueType, (char*)&serviceType, &size) )
		printf( "Failed to read registry value '%s' %s\n", keyname, GetLastErrorText( szErr, 256) );
	
	serviceType &= (0xFFFFFFFF - 0x00000100 );
	if ( interactwithdesktop == TRUE )
		serviceType |= 0x00000100;


	if ( 0 != RegSetValueEx(subkey, keyname, 0, REG_DWORD, (char*)&serviceType, 4 ) )
		printf( "Failed to set registry value %s=%d %s\n", keyname, &serviceType, GetLastErrorText( szErr, 256) );
	*/
	
	RegCloseKey(subkey);
	RegCloseKey(key);
}


///////////////////////////////////////////////////////////////////
//
//  The following code handles service installation and removal
//
//
//  FUNCTION: CmdConfigureService()
//
//  PURPOSE: Installs the service
//
//  PARAMETERS:
//    none
//
//  RETURN VALUE:
//    none
//
//  COMMENTS:
//

void CmdConfigureService( int argc, LPTSTR* argv )
{
    SC_HANDLE   schService;
    SC_HANDLE   schSCManager;
	BOOL ret;
	BOOL ret2;
	DWORD serviceType;
    TCHAR szPath[1024];		

		size_t len;

		if ( strlen(szModulePath) == 0 )
		{
			if ( GetModuleFileName( NULL, szPath, 1024 ) == 0 )
			{
				_tprintf(TEXT("Unable to configure %s - %s\n"), TEXT(SZSERVICEDISPLAYNAME), GetLastErrorText(szErr, 256));
				returnCode = RET_ERROR;
				return;
			}					
			szModulePath = szPath;
		}

		//append -ini <inifile> to modulepath if user specified an ini file on command line
		if ( argc >= 3 )
		{	
			len = strlen( szModulePath ) + 8 + strlen( argv[2] ) + 1;
			if ( len <= 1024 )
			{
				if ( szPath != szModulePath )
				{
					szPath[0] = 0;
					strcat_s( szPath, 1024, szModulePath );
				} 
		
				strcat_s( szPath, 1024, " -ini \"" );
				strcat_s( szPath, 1024, argv[2]  );
				strcat_s( szPath, 1024, "\"" );
				szModulePath = szPath;
			}
			
		}
		_tprintf(TEXT("Installing service with command: %s\n"), szModulePath );


    schSCManager = OpenSCManager(
                        NULL,                   // machine (NULL == local)
                        NULL,                   // database (NULL == default)
                        SC_MANAGER_ALL_ACCESS   // access required
                        );
    if ( schSCManager )
    {
		schService = OpenService( 
			schSCManager,				// handle to service control manager database 
			TEXT(SZSERVICENAME),		// pointer to name of service to start 
			SERVICE_ALL_ACCESS			// type of access to service
		); 

		if ( schService )
        {
        }
        else
        {
            _tprintf(TEXT("OpenService failed - %s\n"), GetLastErrorText(szErr, 256));
			returnCode = RET_ERROR;
			CloseServiceHandle(schSCManager);
			return;
        }

		serviceType = SERVICE_WIN32_OWN_PROCESS;
		if ( interactwithdesktop == TRUE )
			serviceType |= SERVICE_INTERACTIVE_PROCESS;	

        ret =  ChangeServiceConfig(
            schService,					// SCManager database
            serviceType,  // service type
            dwStartType,				// start type
            SERVICE_ERROR_NORMAL,       // error control type
            szModulePath,                     // service's binary
            szLoadOrderGroup,           // load ordering group
            NULL,                       // no tag identifier
            szdependencies,				// dependencies
            szAccount,                  // account
            szPwd,						// password
			TEXT(SZSERVICEDISPLAYNAME)
			);   

		//Configure failure actions		
		_tprintf(TEXT("Configuring Failure Actions\n") );
		ret2 = ChangeServiceConfig2( schService, SERVICE_CONFIG_FAILURE_ACTIONS, &failureActions  );

        if ( ret && ret2 )
        {
            _tprintf(TEXT("%s reconfigured.\n"), TEXT(SZSERVICEDISPLAYNAME) );
			returnCode = RET_SUCCESS;
            CloseServiceHandle(schService);
        }
        else
        {
            _tprintf(TEXT("ConfigureService failed - %s\n"), GetLastErrorText(szErr, 256));
			returnCode = RET_ERROR;
        }

        CloseServiceHandle(schSCManager);

		CmdAddServiceParameterRegistry();
    }
    else
	{
        _tprintf(TEXT("OpenSCManager failed - %s\n"), GetLastErrorText(szErr,256));
		returnCode = RET_ERROR;
	}
}

//
void CmdInstallService( int argc, LPTSTR* argv )
{
    SC_HANDLE   schService;
    SC_HANDLE   schSCManager;
	BOOL ret2 = TRUE;
    TCHAR szPath[1024];	
	DWORD serviceType;
	
		size_t len;

		if ( strlen(szModulePath) == 0 )
		{
			if ( GetModuleFileName( NULL, szPath, 1024 ) == 0 )
			{
				_tprintf(TEXT("Unable to configure %s - %s\n"), TEXT(SZSERVICEDISPLAYNAME), GetLastErrorText(szErr, 256));
				returnCode = RET_ERROR;
				return;
			}					
			szModulePath = szPath;
		}

		//append -ini <inifile> to modulepath if user specified an ini file on command line
		if ( argc >= 3 )
		{	
			len = strlen( szModulePath ) + 7 + strlen( argv[2] ) + 1;
			if ( len <= 1024 )
			{
				if ( szPath != szModulePath )
				{
					szPath[0] = 0;
					strcat_s( szPath, 1024, szModulePath );
				} 
			
				strcat_s( szPath, 1024, " -ini \"" );			
				strcat_s( szPath, 1024, argv[2]  );
				strcat_s( szPath, 1024, "\"" );
				szModulePath = szPath;
			}
			
		}
		_tprintf(TEXT("Installing service with command: %s\n"), szModulePath );

	

    schSCManager = OpenSCManager(
                        NULL,                   // machine (NULL == local)
                        NULL,                   // database (NULL == default)
                        SC_MANAGER_ALL_ACCESS   // access required
                        );
    if ( schSCManager )
    {
		serviceType = SERVICE_WIN32_OWN_PROCESS;
		if ( interactwithdesktop == TRUE )
			serviceType |= SERVICE_INTERACTIVE_PROCESS;	

        schService = CreateService(
            schSCManager,               // SCManager database
            TEXT(SZSERVICENAME),        // name of service
            TEXT(SZSERVICEDISPLAYNAME), // name to display
            SERVICE_ALL_ACCESS | GENERIC_EXECUTE | SERVICE_PAUSE_CONTINUE ,         // desired access
            serviceType,  // service type
            dwStartType,				// start type
            SERVICE_ERROR_NORMAL,       // error control type
			//p0.99
            szModulePath,                     // service's binary
            szLoadOrderGroup,			// load ordering group
            NULL,                       // no tag identifier
            szdependencies,				// dependencies
            szAccount,                  // account
            szPwd);                     // password

		//Create failure actions
		if ( schService )
        {
			_tprintf(TEXT("Configuring Failure Actions\n") );
			
			ret2 = ChangeServiceConfig2( schService, SERVICE_CONFIG_FAILURE_ACTIONS, &failureActions  ); //&failureActions
			if ( !ret2 )
			{
				_tprintf(TEXT("ChangeServiceConfig2 error - %s\n"), GetLastErrorText(szErr, 256));
				CloseServiceHandle(schService);
				schService = NULL;
				CmdRemoveService();
			}
			//_tprintf(TEXT("Actions %d\n"), failureActions.cActions );
			//_tprintf(TEXT("Type %d\n"), failureActions.lpsaActions[0].Type );
		}
		

        if ( schService )
        {
            _tprintf(TEXT("%s installed as a Windows service.\n"), TEXT(SZSERVICEDISPLAYNAME) );
            CloseServiceHandle(schService);
			CmdAddServiceParameterRegistry();
			returnCode = RET_SUCCESS;
        }
        else
        {
            _tprintf(TEXT("CreateService failed - %s\n"), GetLastErrorText(szErr, 256));
			_tprintf(TEXT("Account: %s Password: %s\n"), szAccount, szPwd );
			returnCode = RET_ERROR;
        }

        CloseServiceHandle(schSCManager);

    }
    else
	{
        _tprintf(TEXT("OpenSCManager failed - %s\n"), GetLastErrorText(szErr,256));
		returnCode = RET_ERROR;
	}
}


//
//  FUNCTION: CmdRemoveService()
//
//  PURPOSE: Stops and removes the service
//
//  PARAMETERS:
//    none
//
//  RETURN VALUE:
//    none
//
//  COMMENTS:
//
void CmdRemoveService()
{
    SC_HANDLE   schService;
    SC_HANDLE   schSCManager;

    schSCManager = OpenSCManager(
                        NULL,                   // machine (NULL == local)
                        NULL,                   // database (NULL == default)
                        SC_MANAGER_ALL_ACCESS   // access required
                        );
    _tprintf(TEXT("Removing Service\n") );
	if ( schSCManager )
    {
        schService = OpenService(schSCManager, TEXT(SZSERVICENAME), SERVICE_ALL_ACCESS);

        if (schService)
        {
            // try to stop the service
            if ( ControlService( schService, SERVICE_CONTROL_STOP, &ssStatus ) )
            {
                _tprintf(TEXT("Stopping %s."), TEXT(SZSERVICEDISPLAYNAME));
                Sleep( 1000 );

                while( QueryServiceStatus( schService, &ssStatus ) )
                {
                    if ( ssStatus.dwCurrentState == SERVICE_STOP_PENDING )
                    {
                        _tprintf(TEXT("."));
                        Sleep( 1000 );
                    }
                    else
                        break;
                }

                if ( ssStatus.dwCurrentState == SERVICE_STOPPED )
                    _tprintf(TEXT("\n%s stopped.\n"), TEXT(SZSERVICEDISPLAYNAME) );
                else
                    _tprintf(TEXT("\n%s failed to stop.\n"), TEXT(SZSERVICEDISPLAYNAME) );

            }

            // now remove the service
            if( DeleteService(schService) )
			{
                _tprintf(TEXT("%s removed as a Windows service.\n"), TEXT(SZSERVICEDISPLAYNAME) );
				returnCode = RET_SUCCESS;
			}
            else
			{
                _tprintf(TEXT("DeleteService failed - %s\n"), GetLastErrorText(szErr,256));
				returnCode = RET_ERROR;
			}

            CloseServiceHandle(schService);
        }
        else
		{
            _tprintf(TEXT("OpenService failed - %s\n"), GetLastErrorText(szErr,256));
			returnCode = RET_ERROR;
		}
        CloseServiceHandle(schSCManager);
    }
    else
	{
        _tprintf(TEXT("OpenSCManager failed - %s\n"), GetLastErrorText(szErr,256));
		returnCode = RET_ERROR;
	}
}




///////////////////////////////////////////////////////////////////
//
//  The following code is for running the service as a console app
//


//
//  FUNCTION: CmdDebugService(int argc, char ** argv)
//
//  PURPOSE: Runs the service as a console application
//
//  PARAMETERS:
//    argc - number of command line arguments
//    argv - array of command line arguments
//
//  RETURN VALUE:
//    none
//
//  COMMENTS:
//
void CmdDebugService(int argc, LPTSTR* argv)
{
    DWORD dwArgc;
    LPTSTR *lpszArgv;

#ifdef UNICODE
    lpszArgv = CommandLineToArgvW(GetCommandLineW(), &(dwArgc) );
#else
    dwArgc   = (DWORD) argc;
    lpszArgv = argv;
#endif

    _tprintf(TEXT("Debugging %s.\n"), TEXT(SZSERVICEDISPLAYNAME));

    SetConsoleCtrlHandler( ControlHandler, TRUE );

	//p0.99
	prepare();
    ServiceStart( dwArgc, lpszArgv );
}

///////////////////////////////////////////////////////////////////
//
//  The following code is for running the service as a console app
//

//
//  FUNCTION: CmdRunService(int argc, char ** argv)
//
//  PURPOSE: Runs the service as a console application
//
//  PARAMETERS:
//    argc - number of command line arguments
//    argv - array of command line arguments
//
//  RETURN VALUE:
//    none
//
//  COMMENTS:
//
void CmdRunService(int argc, LPTSTR* argv)
{
    DWORD dwArgc;
    LPTSTR *lpszArgv;

#ifdef UNICODE
    lpszArgv = CommandLineToArgvW(GetCommandLineW(), &(dwArgc) );
#else
    dwArgc   = (DWORD) argc;
    lpszArgv = argv;
#endif

    _tprintf(TEXT("Running %s.\n"), TEXT(SZSERVICEDISPLAYNAME));

    SetConsoleCtrlHandler( ControlHandler, TRUE );

	//p0.99
	prepare();
    ServiceStart( dwArgc, lpszArgv );
}


//
//  FUNCTION: ControlHandler ( DWORD dwCtrlType )
//
//  PURPOSE: Handled console control events
//
//  PARAMETERS:
//    dwCtrlType - type of control event
//
//  RETURN VALUE:
//    True - handled
//    False - unhandled
//
//  COMMENTS:
//
BOOL WINAPI ControlHandler ( DWORD dwCtrlType )
{
    switch( dwCtrlType )
    {
        case CTRL_BREAK_EVENT:  // use Ctrl+Break to simulate service pause and continue
			
			if ( bPaused )
			{	
				ServiceContinue();
				bPaused = FALSE;
			} else
			{
				ServicePause();
				bPaused = TRUE;
			}
			
			return TRUE;
			break;

        case CTRL_C_EVENT:   // SERVICE_CONTROL_STOP in debug mode
            _tprintf(TEXT("Stopping %s.\n"), TEXT(SZSERVICEDISPLAYNAME));
            
			ServiceStop();
            return TRUE;
            break;

     
    }
    return FALSE;
}

void prepare()
{	
	char dateTime[20];
	TCHAR szPath[512];

    dateTimeToString (dateTime, "%Y-%m-%d %H:%M:%S");
	//redirect stdout and stderr with check for overwriting
	//redirect stdout and stderr with check for overwriting

	if ( strlen( stdoutfile ) != 0 )
	{
		strcpy_s( szPath, 512, stdoutfile );
		timestampFile(szPath);
		if (stdOutAppend) {     
			if (freopen_s( &restdout, szPath, "a", stdout ) == 0) {
				fprintf(restdout,"---- Logfile startet: %s\n",dateTime);
				fflush(restdout);
			}
			else if ( bDebug ) {
				char buffer[128]; sprintf_s(buffer, 128, "freopen_s(..., \"a\", stdout) fail [errno=%d]", errno);
				logToFile( buffer );
				logToFile( szPath );
			}    
		} else {
			if (freopen_s( &restdout, szPath, "w", stdout ) != 0) {
				fprintf(restdout,"---- Logfile startet: %s\n",dateTime);
				fflush(restdout);
			}
			else if ( bDebug ) {
				char buffer[128]; sprintf_s(buffer, 128, "freopen_s(..., \"a\", stdout) fail [errno=%d]", errno);
				logToFile( buffer );
				logToFile( szPath );
			}
		}
	}

	if ( strlen( stderrfile ) != 0 ) 
	{
		strcpy_s( szPath, 512, stderrfile );
		timestampFile(szPath);
		if (stdErrAppend) {
			if (freopen_s( &restderr, szPath, "a", stderr ) == 0) {
				fprintf(restderr,"---- Logfile startet: %s\n",dateTime);
				fflush(restderr);
			}
			else if ( bDebug ) {
				char buffer[128]; sprintf_s(buffer, 128, "freopen_s(..., \"a\", stderr) fail [errno=%d]", errno);
				logToFile( buffer );
				logToFile( szPath );
			}
		} else {
			if (freopen_s( &restderr, szPath, "w", stderr ) != 0) {
					fprintf(restderr,"---- Logfile startet: %s\n",dateTime);
					fflush(restderr);
			}
			else if ( bDebug ) {
				char buffer[128]; sprintf_s(buffer, 128, "freopen_s(..., \"a\", stderr) fail [errno=%d]", errno);
				logToFile( buffer );
				logToFile( szPath );
			}	
		}
	}

    if ( bDebug )
        logToFile( "prepare stdxxx - end" );
}


void cleanup()
{
	if ( restdout )
	{
		fclose( restdout );
		restdout = NULL;
	}
	if ( restderr )
	{
		fclose( restderr );
		restderr = NULL;
	}

	if ( bDebug )
		logToFile( "Cleanup complete" );
}

//
//  FUNCTION: GetLastErrorText
//
//  PURPOSE: copies error message text to string
//
//  PARAMETERS:
//    lpszBuf - destination buffer
//    dwSize - size of buffer
//
//  RETURN VALUE:
//    destination buffer
//
//  COMMENTS:
//
LPTSTR GetLastErrorText( LPTSTR lpszBuf, DWORD dwSize )
{
    DWORD dwRet;
    LPTSTR lpszTemp = NULL;

    dwRet = FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM |FORMAT_MESSAGE_ARGUMENT_ARRAY,
                           NULL,
                           GetLastError(),
                           LANG_NEUTRAL,
                           (LPTSTR)&lpszTemp,
                           0,
                           NULL );

    // supplied buffer is not long enough
    if ( !dwRet || ( (long)dwSize < (long)dwRet+14 ) )
        lpszBuf[0] = TEXT('\0');
    else
    {
        lpszTemp[lstrlen(lpszTemp)-2] = TEXT('\0');  //remove cr and newline character
		#ifdef VC6
        _stprintf( lpszBuf, TEXT("%s (0x%x)"), lpszTemp, GetLastError() );
		#else
		_stprintf_s( lpszBuf, dwSize, TEXT("%s (0x%x)"), lpszTemp, GetLastError() );
		#endif
    }

    if ( lpszTemp )
        LocalFree((HLOCAL) lpszTemp );

    return lpszBuf;
}

#ifdef VC6
void strcat_s( char* dest, size_t sDest, char* src  )
{
	strcat( dest, src);
}

void strcpy_s( char* dest, size_t sDest, char* src  )
{
	strcpy( dest, src);
}

void localtime_s( struct tm* _tm, time_t* timer )
{
	_tm = localtime( timer );
}

size_t fopen_s( FILE** pFile, const char* fname, const char* mode )
{
	*pFile = fopen( fname, mode );
	if ( *pFile != NULL )
		return 0;
	else return 1;
}

size_t freopen_s( FILE** pFile, const char* fname, const char* mode, FILE* stream )
{
	*pFile = freopen( fname, mode, stream );
	if ( *pFile != NULL )
		return 0;
	else return 1;
}

int _snprintf_s( char* dest, size_t sDest, size_t count, char* format, char* p1 )
{
	return _snprintf( dest, count, format, p1 );	
}

#endif


